<?php
define ('CFG_SKIP_STRIP_TAGS', true);
require_once "LocalSettings.php";

Navigation::adminNavi();

if (isset($_POST['submit'])) {
    $announcement = new Announcement();
    $announcement->setData($_POST);
    // Даты надо переделать в unix timestamp'ы
    $start_publish_arr = explode(".", $_POST['start_publish']);
    $start_publish = mktime(0, 0, 0, $start_publish_arr[1], $start_publish_arr[0], $start_publish_arr[2]);
    $end_publish_arr = explode(".", $_POST['end_publish']);
    $end_publish = mktime(23, 59, 59, $end_publish_arr[1], $end_publish_arr[0], $end_publish_arr[2]);
    $announcement->set('start_publish', $start_publish);
    $announcement->set('end_publish',   $end_publish);
    if ($announcement->validate())
        $announcement->save();
} elseif (isset($_GET['edit'])) {
    $announcement = new Announcement($_GET['edit']);
    $tpl->assign('cur_announcement', $announcement);
} elseif (isset($_GET['delete'])) {
    $announcement = new Announcement($_GET['delete']);
    $announcement->delete();
    $ssn->redirectTo($_SERVER['PHP_SELF']);
}

$hand_announcement_cont = new HandledAnnouncementContainer("", $_GET['order_by'], $_GET['order_asc']);
$ph = $hand_announcement_cont->loadAll();
$tpl->assign('announcements', $hand_announcement_cont->getAll());
$tpl->assign("ph", $ph);
$tpl->assign("items_pp", $hand_announcement_cont->getItemsPP());

$table_fields = array(
    'start_publish'         => $lang->get("label__start_publish"),
    'end_publish'           => $lang->get("label__end_publish"),
    'text_en'               => $lang->get("label__text_en"),
    'text_lv'               => $lang->get("label__text_lv"),
    'text_ru'               => $lang->get("label__text_ru")
);
$tpl->assign("table_fields", $table_fields);

$field_modifiers = array(
    'start_publish'         => 'date',
    'end_publish'           => 'date',
    'text_lv'               => 'strip_truncate',
    'text_ru'               => 'strip_truncate'
);
$tpl->assign("field_modifiers", $field_modifiers);

Messages::formatAll();
$tpl->assign('page_title', $lang->get('navi__announcements'));
$tpl->assign('main_template', 'Admin_Announcements.html');
$tpl->display('Fend_Index.html');
?>