<?php
require_once "LocalSettings.php";

Navigation::adminNavi();

$packet_gr_container = new HandledPacketGroupContainer("", $_GET['order_by'], $_GET['order_asc']);
$ph = $packet_gr_container->loadAll();
$tpl->assign("ph", $ph);
$packet_groups = $packet_gr_container->getAll();
$tpl->assign("packet_groups", $packet_groups);
$tpl->assign("items_pp", $packet_gr_container->getItemsPP());

if (isset($_POST['save'])){
    $packet_gr = new PacketGroup();
    $packet_gr->setData($_POST);
    if ($packet_gr->validate()){
        $packet_gr->save();
        $ssn->redirectTo($_SERVER['PHP_SELF']);
    }
    $tpl->assign('packet_group', $packet_gr);
} elseif (isset($_GET['edit'])){
    $tpl->assign('packet_group', $packet_gr_container->get($_GET['edit']));
} elseif (isset($_GET['delete'])){
    $to_delete = $packet_groups[$_GET['delete']];
    if (is_object($to_delete)){
        $to_delete->delete();
        $ssn->redirectTo($_SERVER['PHP_SELF']);
    }
}

$tpl->assign("table_fields", array(
    'packet_group'  => $lang->get("label__packet_group"),
    'price'         => $lang->get("label__packet_group_price")
));
$tpl->assign('page_title',  $lang->get('title__packet_groups'));
Messages::formatAll();
$tpl->assign("main_template", "Admin_Packet_Groups.html");
$tpl->display("Fend_Index.html");
?>