<?php
require_once "LocalSettings.php";

Navigation::adminNavi();

$packet_container = new HandledPacketContainer("", $_GET['order_by'], $_GET['order_asc']);
$ph = $packet_container->loadAll();
$tpl->assign("ph", $ph);
$packets = $packet_container->getAll();
$tpl->assign("packets", $packets);
$tpl->assign("items_pp", $packet_container->getItemsPP());
$packet_group_cont = new PacketGroupContainer();
$packet_group_cont->loadAll();
$tpl->assign("packet_groups", $packet_group_cont->getAll());

if (isset($_POST['save'])){
    $packet = new Packet();
    $packet->setData($_POST);
    if ($packet->validate()){
        $packet->save();
        $ssn->redirectTo($_SERVER['PHP_SELF']);
    }
    $tpl->assign('packet', $packet);
} elseif (isset($_GET['edit'])){
    $tpl->assign('packet', $packet_container->get($_GET['edit']));
} elseif (isset($_GET['delete'])){
    $to_delete = $packet_container->get($_GET['delete']);
    if (is_object($to_delete)) {
        $to_delete->delete();
        $ssn->redirectTo($_SERVER['PHP_SELF']);
    }
}

//print_r($packets);
$coding_cont = new CodingContainer();
$coding_variants = $coding_cont->getAll();
$tpl->assign("coding_variants", $coding_variants);
$tpl->assign("table_fields", array(
    'coding'        => $lang->get("label__packet_coding"),
    'packet'        => $lang->get("label__packet_packet"),
    'port'          => $lang->get("label__packet_port"),
	'name_wicardd'  => $lang->get("label__name_wicardd"),
    'name'          => $lang->get("label__packet_name"),
    'packet_group'  => $lang->get("label__packet_group")
));
$tpl->assign("field_modifiers", array(
    'packet_group'  => "packet_group"
));

$tpl->assign('page_title',  $lang->get('title__packets'));
Messages::formatAll();
$tpl->assign("main_template", "Admin_Packets.html");
$tpl->display("Fend_Index.html");
?>