<?php

require_once "LocalSettings.php";

Navigation::adminNavi();

$items_pp_default = 10;
if (isset($_GET['items_pp']))
{
    $items_pp = intval($_GET['items_pp']);
} else
    $items_pp = $_SESSION["PageHandlerData"]["HandledActiveRecordContainer"][""]["items_pp"];
if ($items_pp <= 0)
{
    $items_pp = $items_pp_default;
}
$_SESSION["PageHandlerData"]["HandledActiveRecordContainer"][""]["items_pp"] = $items_pp;
if (isset($_GET['page']))
{
    $page = intval($_GET['page']);
} else
    $page = $_SESSION["PageHandlerData"]["HandledActiveRecordContainer"][""]["page"];
if ($page < 1)
    $page = 1;
$_SESSION["PageHandlerData"]["HandledActiveRecordContainer"][""]["page"] = $page;

$tpl->assign("items_pp", $items_pp);




$db = new Database('User::Bonus');
$db->query('SELECT count(*) as numrows FROM `user_bonus`');
$numRows=0;
if ($db->nextRecord())
    $numRows = $db->f('numrows');


        $start = ($page - 1) * $items_pp;
        if ($start >= $numRows){
            $page = ceil($numRows / $items_pp);
            $start = ($page - 1) * $items_pp;
        }

        $pH = '';
        if ($numRows > $items_pp){
            foreach ($_GET AS $k => $v) {
                if ($k != 'page') {
                    $get .= "$k=$v&";
                }
            }
            $get = preg_replace ( "/&$/", "", $get );
            $pH = PageHandlers::stdPageHandler($_SERVER['PHP_SELF'], $get, $items_pp, $numRows, $page);
            $limits = ' LIMIT '.$start.','.$items_pp;
        }


$db = new Database('User::Bonus');
$db->query('SELECT * FROM `user_bonus` ORDER BY time_added DESC'.$limits);
$users_b = array();
while ($db->nextRecord())
{
    $data = array($db->f('login'), $db->f('time_added'), $db->f('bonus'));
    $users_b[] = $data;
}

$tpl->assign("records", $users_b);
$tpl->assign("ph", $ph);


$tpl->assign("table_fields", array(
    'login' => $lang->get("label__user_login"),
    'time_added' => $lang->get("label__user_time_added"),
    'balance' => $lang->get("label__balance")));


$tpl->assign("field_modifiers", array('disabled' => "modDot", 'confirmed' =>
    "modDot", 'email' => "mailto", 'time_added' => "date", 'time_edited' => "date"));
$tpl->assign('page_title', $lang->get('title__users'));
Messages::formatAll();
$tpl->assign("main_template", "Admin_User_Bonus.html");
$tpl->display("Fend_Index.html");

?>