<?php
require_once "LocalSettings.php";

Navigation::adminNavi();

function createUser($user_login)
{
    $user = new User($user_login);
    if (!$user->isLoaded()){
        // юзер не загружен из БД - видимо, логин неверный
        $lang = Language::getInstance();
        Messages::setUserErrorMsg($lang->get('error__no_such_user', array(
            'login'     => $user_login
        )));
        return null;
    }
    return $user;
}

if (isset($_POST['submit'])){
    $user_login = $_POST['user_login'];
    $user = createUser($user_login);
    if ($user != null){
        $user_packet_groups = $_POST['user_packet_groups'];
        $packet_cont = new UserPacketGroupContainer();
        $packet_cont->deleteByGroups($user_packet_groups, $user_login);
        // Новая дата
        $time_till_arr = explode(".", $_POST['time_till_text']);
        $time_till = mktime(12, 0, 0, $time_till_arr[1], $time_till_arr[0], $time_till_arr[2]);
        $packet_gr = new UserPacketGroup();
        $packet_gr->set('login', $user_login);
        $packet_gr->set('time_till', $time_till);
        foreach ($user_packet_groups as $packet_group){
            $packet_gr->set('packet_group', $packet_group);
            $packet_gr->save();
        }
		DaemonControl22::regenConfig();
        $ssn->redirectTo('user_details.php?details=' . $user_login);
        /*
        $user_packets = $_POST['user_packets'];
        $packet_cont = new UserPacketContainer();
        $packet_cont->deleteByPackets($user_packets);
        // Новая дата
        $time_till_arr = explode(".", $_POST['time_till_text']);
        $time_till = mktime(12, 0, 0, $time_till_arr[1], $time_till_arr[0], $time_till_arr[2]);
        $packet = new UserPacket();
        $packet->set('login', $user_login);
        $packet->set('time_till', $time_till);
        foreach ($user_packets as $packet_id){
            $packet->set('packet_id', $packet_id);
            $packet->save();
        }
        $ssn->redirectTo('user_details.php?details=' . $user_login);
        */
    }
} else {
    $user_login = $_GET['details'];
    $user = createUser($user_login);
}
$tpl->assign('user_login', $user_login);

if ($user != null) {
    $tpl->assign('user', $user);
    // контейнер всех пакетов
    /*
    $packet_cont = new PacketContainer();
    $packet_cont->loadAll();
    $packets = $packet_cont->getAll();
    $tpl->assign('packets', $packets);
    */
    $packet_group_cont = new PacketGroupContainer();
    $packet_group_cont->loadAll();
    $tpl->assign('packet_groups', $packet_group_cont->getAll());

    $user_packet_group_cont = new UserPacketGroupContainer();
    $user_packet_group_cont->loadActiveByUser($user_login);
    $user_packet_groups = $user_packet_group_cont->getAll();
    $user_packet_groups = $user_packet_groups[$user_login];
    $tpl->assign('user_packet_groups', $user_packet_groups);
    /*
    $user_packet_cont = new UserPacketContainer();
    $user_packet_cont->loadActiveByUser($user_login);
    $user_packets = $user_packet_cont->getAll();
    $tpl->assign('user_packets', $user_packets);
    */
}
Messages::formatAll();
$tpl->assign('page_title',  $lang->get('title__user_details'));
$tpl->assign("main_template", "Admin_User_Details.html");
$tpl->display("Fend_Index.html");
?>