<?php
abstract class DaemonControl {
    public static function getLog($line_count)
    {
        $line_count = intval($line_count);
        $handle = popen("tail -n " . $line_count . " " . ConstTrans::TRANS_LOG, 'r');
        while (!feof($handle)) {
            $log_contents .= fgets($handle, 4096);
        }
        pclose($handle);
        return $log_contents;
		}
    public static function getLog2($line_count)
    {
        $line_count = intval($line_count);
        $handle = popen("tail -n " . $line_count . " " . ConstTrans::TRANS_2_LOG, 'r');
        while (!feof($handle)) {
            $log_contents .= fgets($handle, 4096);
        }
        pclose($handle);
        return $log_contents;
    }
	 public static function getLog3($line_count)
    {
        $line_count = intval($line_count);
        $handle = popen("tail -n " . $line_count . " " . ConstTrans::TRANS_3_LOG, 'r');
        while (!feof($handle)) {
            $log_contents .= fgets($handle, 4096);
        }
        pclose($handle);
        return $log_contents;
    }
    public static function control($action)
    {
        if (!in_array($action, array(
            'start',
            'stop',
			 'restart',
			 'force-reload',
			'users',
			'stat',
			'copy-gen',
			'mysql-restart',
			'ip-check',
			'info',
            'status'
        )))
            return false;
        $handle = popen("sudo " . ConstTrans::TRANS_INITSCRIPT . " " . $action, 'r');
        while (!feof($handle)) {
            $reply .= fgets($handle, 4096);
        }
        return $reply;
    }

    /*

    // самое весёлое
    public static function regenConfig()
    {
        // создание конфигурационного файла
        $user_pac_cont = new UserPacketContainer();
        $user_pac_cont->loadActive();
        $user_packets = $user_pac_cont->getAll();
        $logins = $user_pac_cont->getLogins();
        $user_cont = new UserContainer();
        $user_cont->loadByIDs($logins);
        $packet_cont = new PacketContainer();
        $packet_cont->loadByIDs(array_keys($user_packets));

        print_r($packets);
        foreach ($user_packets as $packet_id => $user_packet){
            $login = $user_packet->get('login');
            $user = $user_cont->get($login);
            if ($user->get('disabled') != 1){
                $password = $user->get('password');
                $packet = $packet_cont->get($packet_id);
                if (is_object($packet))
                    $result[$login . ":" . $password][$packet->get('coding')][] = $packet->get('packet');
            }
        }
        // Генерируем файл конфига
        // сначала копируем темплейт
        copy(CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_SERVER_CFG_TEMPLATE_REL, ConstTrans::TRANS_SERVER_CFG);
        $config_file = fopen(ConstTrans::TRANS_SERVER_CFG, 'a');
        foreach ($result as $logpass => $user_packets_data){
            fwrite($config_file, $logpass . " nospider nocascade");
            foreach ($user_packets_data as $coding => $packets){
                fwrite($config_file, " " . $coding . "&" . implode(",", $packets));
            }
            fwrite($config_file, "\n");
        }
        fclose($config_file);
    }
    */
    public static function regenConfig()
    {

        // создание конфигурационного файла
        $user_pac_gr_cont = new UserPacketGroupContainer();
        $user_pac_gr_cont->loadActive();
        $user_packet_groups = $user_pac_gr_cont->getAll();
        $logins = $user_pac_gr_cont->getLogins();
     //   print "\n=========\n<pre>";
     //   print_r($user_packet_groups);
     //   print "\n=========\n</pre>";

        $user_cont = new UserContainer();
        $user_cont->loadByIDs($logins);
        //$user_cont->loadAll();
				
	
			  //print "\n=========\n<pre>";
		  	//print_r ($user_cont);
		  	//print "\n=========\n</pre>";
				
			
        $packet_cont = new PacketContainerGrouped();
        $packet_cont->loadAll();
        $packets_grouped = $packet_cont->getAll();
       	$server_user_count[1] = 0;

        foreach ($user_packet_groups as $login => $packet_groups_tmp){
            foreach ($packet_groups_tmp as $packet_group => $user_packet_group_all) foreach ($user_packet_group_all as $packet_group_key => $user_packet_group){
		if ($user_packet_group->get('time_from')>time()) continue;
        
		// print "aa\n";
                $packets = $packets_grouped[$packet_group];
                $login = $user_packet_group->get('login');
                $user = $user_cont->get($login);
				//if ($user->get('pause')>0) continue;
               $server_user_count[1]++;				
                if (is_object($user) && $user->get('confirmed') == 1){
							 	    $server = $user->get('server_n');
                    $password = $user->get('password');
                    if (!empty($packets)) {
                        foreach ($packets as $packet){
                            if (is_object($packet)) {

                                $result["\n" . "[account]" 
		      . "\n" . "user = " . $login 
		      . "\n" . "pwd = " . $password 
		      . "\n" . "group = 1" 
		      . "\n" . "uniq = 2" 
		      . "\n" . "cccignorereshare = 1" 
		      . "\n" . "cccstealth = 0" 
		      . "\n" . "penalty = 1" 
		      . "\n" . "NumUsers = 1" 
		      . "\n" . "ident = "][$packet->get('coding')][] = $packet->get('packet');
		
				$result_server ["\n" . "[account]" 
			. "\n" . "user = " . $login 
			. "\n" . "pwd = " . $password 
			. "\n" . "group = 1" 
			. "\n" . "uniq = 2" 
			. "\n" . "cccignorereshare = 1" 
			. "\n" . "cccstealth = 0" 
			. "\n" . "penalty = 1" 
			. "\n" . "NumUsers = 1" 
			. "\n" . "ident = "]= $server;

                                //print $login . ":" . $password . "\n";
                            } //else print "packet is not an object!\n";
                        }
                    } //else print "empty packets from $packet_group\n";
                } //else print $login . " is obsolete\n";
            }
        }
        //print "result:\n<pre>";
        //print_r($result);
				//print_r($result_server);
        //print "\n</pre>";

				
				 $servers = new ServerLoad();
				 $servers -> load();
				 //$servers -> getAll();
				 foreach ($servers as $server) foreach ($server as $num=>$value) {
				 		
				// echo CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_SERVER_CFG_TEMPLATE_REL.", ".str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_SERVER_CFG);
				  copy(CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_SERVER_CFG_TEMPLATE_REL, str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_SERVER_CFG));
          $config_file[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_SERVER_CFG), 'a');
					
				 }
	

        // Генерируем файл конфига
				// сначала копируем темплейт
        //  copy(CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_SERVER_CFG_TEMPLATE_REL, ConstTrans::TRANS_SERVER_CFG);
        //  $config_file = fopen(ConstTrans::TRANS_SERVER_CFG, 'a');
				$servers_user_count = array();
        foreach ($result as $logpass => $user_packets_data){
            $servers_user_count[$result_server[$logpass]]++;
            fwrite($config_file[$result_server[$logpass]], $logpass . "");
            foreach ($user_packets_data as $coding => $packets){
                fwrite($config_file[$result_server[$logpass]], $coding . ":" . implode(",", $packets) .";");
            }
            fwrite($config_file[$result_server[$logpass]], "\n");
        }			
							
				foreach ($servers as $server) foreach ($server as $num=>$value) {
				  $servers->setData(array($num=>$servers_user_count[$num]));
					fclose($config_file[$num]);
				}
        $servers->save();
    

	
       foreach ($user_packet_groups as $login => $packet_groups_tmp){
            foreach ($packet_groups_tmp as $packet_group => $user_packet_group_all) foreach ($user_packet_group_all as $packet_group_key => $user_packet_group){
		if ($user_packet_group->get('time_from')>time()) continue;
                $packets = $packets_grouped[$packet_group];
                $login = $user_packet_group->get('login');
                $user = $user_cont->get($login);
				//if ($user->get('pause')>0) continue;
                if (is_object($user) && $user->get('confirmed') == 1){
                    $password = $user->get('password');
                    if (!empty($packets)) {
                        foreach ($packets as $packet){
                            if (is_object($packet)) {


                                $result6["\n" . "[account]" 
		      . "\n" . "user = " . $login 
		      . "\n" . "pwd = " . $password 
		      . "\n" . "group = 1" 
		      . "\n" . "uniq = 2" 
		      . "\n" . "cccignorereshare = 1" 
		      . "\n" . "cccstealth = 0" 
		      . "\n" . "penalty = 1" 
		      . "\n" . "NumUsers = 1" 
		      . "\n" . "ident = "][$packet->get('coding')][] = $packet->get('packet');
		
		  $result_server ["\n" . "[account]" 
			. "\n" . "user = " . $login 
			. "\n" . "pwd = " . $password 
			. "\n" . "group = 1" 
			. "\n" . "uniq = 2" 
			. "\n" . "cccignorereshare = 1" 
			. "\n" . "cccstealth = 0" 
			. "\n" . "penalty = 1" 
			. "\n" . "NumUsers = 1" 
			. "\n" . "ident = "]= $server;




				//print $login . ":" . $password . "\n";
                            } //else print "packet is not an object!\n";
                        }
                    } //else print "empty packets from $packet_group\n";
                } //else print $login . " is obsolete\n";
            }
        }
foreach ($servers as $server) foreach ($server as $num=>$value) {
         copy(CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_2_SERVER_CFG_TEMPLATE_REL,  str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_2_SERVER_CFG));
        $config_file6[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_2_SERVER_CFG), 'a');
		 }
				$servers_user_count = array();
        foreach ($result6 as $logpass => $user_packets_data){
            $servers_user_count[$result_server[$logpass]]++;
            fwrite($config_file6[$result_server[$logpass]], $logpass . "");
            foreach ($user_packets_data as $coding => $packets){
                fwrite($config_file6[$result_server[$logpass]], $coding . ":" . implode(",", $packets) .";");
            }
            fwrite($config_file6[$result_server[$logpass]], "\n");
        }			
							
				foreach ($servers as $server) foreach ($server as $num=>$value) {
				  $servers->setData(array($num=>$servers_user_count[$num]));
					fclose($config_file6[$num]);
				}
        $servers->save();                                                                                                         
 foreach ($servers as $server) foreach ($server as $num=>$value) {
         copy(CFG_PROJECT_ROOT . "/" . ConstTrans::TRANS_3_SERVER_CFG_TEMPLATE_REL,  str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_3_SERVER_CFG));
        $config_file6[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_3_SERVER_CFG), 'a');
		 }
		 $servers_user_count = array();
        foreach ($result6 as $logpass => $user_packets_data){
		 $servers_user_count[$result_server[$logpass]]++;
        $kkkkk=0;
	foreach ($user_packets_data as $coding => $packets){
	if ($coding == '0500') {
	$kkkkk=$kkkkk+1;
	}}
	if ($kkkkk != 0 ) {
            fwrite($config_file6[$result_server[$logpass]], $logpass . " nospider nocascade maxreconnects&7 ");
            foreach ($user_packets_data as $coding => $packets){
	         	if ($coding == '0500') {
            fwrite($config_file6[$result_server[$logpass]], $coding . ":" . implode(",", $packets) .";");
            }}
            fwrite($config_file6[$result_server[$logpass]], "\n");
            }}
        fclose($config_file6[$num]);                                      
#DaemonControl::regenConfig_for_finished_packets();
    }

public static function regenConfig_for_finished_packets()
{
$finished_result=mysql_query("select x.login,y.password from user_packet_groups x, users y where x.login NOT IN (select distinct login from user_packet_groups where time_till>".time().") and x.login=y.login group by login");
$config_file[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_SERVER_CFG), 'a');
$config_file6[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_2_SERVER_CFG), 'a');
$config_file6[$num] = fopen(str_replace('.cfg', $num.'.cfg', ConstTrans::TRANS_3_SERVER_CFG), 'a');

while (@$myrow=mysql_fetch_array($finished_result)) {
$login=$myrow['login'];
$password=$myrow['password'];
fwrite($config_file[$result_server[$logpass]], $login .":".$password. " disable\n");
fwrite($config_file6[$result_server[$logpass]], $login .":".$password. " disable\n");
}
foreach ($finished_result as $login => $password) {
fwrite($config_file[$result_server[$logpass]], $login .":".$password. " disable");
fwrite($config_file6[$result_server[$logpass]], $login .":".$password. " disable");
}
 fwrite($config_file[$result_server[$logpass]], "\n");
fclose($config_file[$num]);
 fwrite($config_file6[$result_server[$logpass]], "\n");
fclose($config_file6[$num]);
}

	}
?>