<?php
require_once('HtmlMimeMail/HtmlMimeMail.php');

class SimpleMail extends htmlMimeMail {

    function SimpleMail ($pconstruct = true)
    {
    }


    function &getInstance()
    {
        static $mail;

        if (!is_object($mail)) {
            $mail = new SimpleMail();
        }

        return $mail;
    }

    function formatedMail ($text, $vars = '') {
        $mails_text = array();
        $html   = $text['html'];
        $txt    = $text['txt'];
        foreach ($vars as $key => $val) {
           $html = str_replace ('$'.$key, $val, $html);
           $txt  = str_replace ('$'.$key, strip_tags($val), $txt);
        }
        return array('html' => $html, 'txt' => $txt);
    }

    function sendMail ($subject, $email, $mails_text, $from_name = '', $from_email = '', $vars)
    {
        $this->setTextCharset('UTF-8');
        $this->setHtmlCharset('UTF-8');
        $this->setHeadCharset('UTF-8');

        if (Messages::userErrorsEx()  < 1) {
            $this->setReturnPath(ConstEmail::ADMIN_EMAIL);

            if ($from_email == '') {
                $this->setFrom(ConstEmail::ADMIN_NAME . ' <' . ConstEmail::ADMIN_EMAIL . '>');
            } else {
                $this->setFrom($from_name.' <'. $from_email .'>');
            }

            $this->setSubject($subject);
            $this->setHeader('X-Mailer', 'HTML Mime mail class (HTMLMimeMail)');

            $mails_text = $this->formatedMail($mails_text, $vars);
            $this->setHtml($mails_text['html'], $mails_text['txt']);
            $res = $this->send(array($email));
            //$res = true;
            if (!$res) {
                Messages::setMailMsg('Email to ' . $email . ' has not been send!', __FILE__, __LINE__);
                Messages::setLogMsg('Email to ' . $email . ' has not been send!', __FILE__, __LINE__);
                Messages::setUserErrorMsg('Email to ' . $email . ' has not been send!');
            }
            return $res;
        } else {
            return false;
        }
    }

}
?>