<?php
require_once "smarty/Smarty.class.php";

class Template extends Smarty {

    public function Template ($pconstruct = true)
    {
        if ($pconstruct){
            $this->Smarty();
        }

        $this->debugging = ConstMisc::SMARTY_DEBUG;

        $template_path = CFG_PROJECT_ROOT . "/" . ConstPaths::TEMPLATE_DIR;
        $this->template_dir     = $template_path . 'templates';
        $this->compile_dir      = $template_path . 'templates_c';
        $this->config_dir       = $template_path . 'config';
        $this->cache_dir        = $template_path . 'cache';
        $plugins_dir = CFG_PROJECT_ROOT . "/" . ConstPaths::INCLUDE_DIR . "/smarty/plugins";
        $this->plugins_dir      = $plugins_dir;
    }

    public function phpSelf()
    {
        $ssn =& Session::getInstance();
        $this->assign('php_self', $ssn->Url($_SERVER['PHP_SELF']));
    }

    public static function &getInstance()
    {
        static $tpl;
        if (!is_object($tpl)) {
            $tpl = new Template();
        }
        return $tpl;
    }
}
?>