<?php
require_once "LocalSettings.php";

Navigation::guestNavi();

if (isset($_POST['submit'])) {
    require_once "securimage/securimage.php";
    $new_user = new User();
    // Не позволяем подделать некоторые данные
    unset($_POST['balance']);
    unset($_POST['discount']);
    unset($_POST['disabled']);
    $new_user->setData($_POST);
    $new_user->set('time_added', time());
    $new_user->set('confirmed', 1);
    $login = $_POST['login'];
    $email = $_POST['email'];
    // Проверка капчи
    $img = new Securimage();
    $valid = $img->check($_POST['captcha']);
    if (!$valid)
        Messages::setUserErrorMsg($lang->get('err__wrong_captcha'));
    if ($valid && $new_user->validate() && $new_user->checkUnique() && $new_user->setPassword($_POST['password_new'], $_POST['password_confirm'])) {
        $new_user->save();
        // Создать подтверждение
        // Это не надо
        /*
        $conf_key = new ConfirmKey($_POST['login']);
        $key = Confirm::generateKey($login);
        $link = ConstMisc::SITE_ADDRESS . "confirm.php?key=" . $key . "&login=" . $login;
        $mail = new Mail();
        $mail_vars = array(
            'site_name' => ConstMisc::SITE_NAME,
            'link'      => $link
        );
        $mail->sendMail($email, 'registration_confirmation', $lang->getLang(), $mail_vars);
        $conf_key->set('conf_key', $key);
        $conf_key->save();
        */
        $ssn->redirectTo('register_successfull.php');
    } else {
        $tpl->assign('user', $new_user);
    }
}

$tpl->assign('page_title',  $lang->get('title__register'));
Messages::formatAll();
$tpl->assign("main_template", "User_Register.html");
$tpl->display("Fend_Index5.html");

?>