function processTimer()
{
    var event = 0;
    var Dtime = new Date();
    Hdiff = - Math.ceil(Dtime.getTimezoneOffset() / 60) - 2;
    hourVal = Dtime.getHours() - Hdiff;
    if (hourVal < 0)
        hourVal = hourVal + 24;
    minuteVal = Dtime.getMinutes();
    secondVal = Dtime.getSeconds();
    var t = (hourVal * 60 + minuteVal) * 60 + secondVal;

    var restartTimes = new Array();
    restartTimes = [0,3,6,9,12,15,18,21];

    for(var k in restartTimes)
    {
        restartTime = parseInt(k) + 1;
        if(!restartTimes[restartTime])
        {
            restartTime = 0;
            restartTimes[restartTime] = 24 + restartTimes[restartTime];
        }

        if(( hourVal > restartTimes[k] && restartTimes[restartTime] > hourVal ) || hourVal == restartTimes[k])
            event = restartTimes[restartTime];
    }

    t = event * 60 * 60 - t;
    hourVal = Math.floor(t / 3600);
    minuteVal = Math.floor((t % 3600) / 60);
    secondVal = (t % 3600) % 60;

    var elTimer = document.getElementById("timer");
    if (elTimer)
    {
        var sHour       = new String(hourVal);
        var sMinute     = new String(minuteVal);
        var sSecond     = new String(secondVal);
        if (hourVal < 10)
            sHour = "0" + hourVal;
        if (minuteVal < 10)
            sMinute = "0" + minuteVal;
        if (secondVal < 10)
            sSecond = "0" + secondVal;

        elTimer.innerHTML =   sHour + ":" + sMinute + ":" + sSecond;
    }
}

function startTimer()
{
    processTimer();
    setInterval("processTimer()",1000);
}