<?php
require_once "CMysql.php";

// a wrapper class around the DB_MySQL class
class Database {
    protected $fname;
    protected $db;

    public function Database($fname)
    {
        $this->fname = $fname;
        $this->db =& DB_MySQL::getInstance();
    }

    public function free()
    {
        return $this->db->free($this->fname);
    }

    public function query($query_string)
    {
        return $this->db->query($query_string, $this->fname);
    }

    public function custom_query($query_string)
    {
        return $this->db->custom_query($query_string, $this->fname);
    }

    public function nextRecord()
    {
        return $this->db->nextRecord($this->fname);
    }

    public function seek($pos = 0)
    {
        return $this->db->seek($this->fname, $pos);
    }

    public function lock($table, $mode = "write")
    {
        return $this->db->lock($table, $mode);
    }

    public function unlock()
    {
        return $this->db->unlock();
    }

    public function affectedRows()
    {
        return $this->db->affectedRows($this->fname);
    }

    public function numRows()
    {
        return $this->db->numRows($this->fname);
    }

    public function numFields()
    {
        return $this->db->numFields($this->fname);
    }

    public function f($name)
    {
        return $this->db->f($name, $this->fname);
    }

    public function nextid($seq_name)
    {
        return $this->db->nextid($seq_name, $this->fname);
    }

    public function metadata($table = "", $full = false)
    {
        return $this->db->metadata($table = "", $full = false, $this->fname);
    }

    public function row()
    {
        return $this->db->row($this->fname);
    }

    public function insertId()
    {
        return $this->db->insertId();
    }
}
?>