<?php

class LangList{
    private $lang_list;

    public function LangList()
    {
        $this->load();
    }

    protected function load()
    {
        $this->lang_list = array();
        $fname = "LangList::load";
        $sql =  " SELECT * " .
                " FROM " . ConstDB::TBL_ALL_LANG_LIST;
        $db =& DB_MySQL::getInstance();
        $db->query($sql, $fname);
        while ($db->nextRecord($fname)){
            $this->lang_list[$db->f('lang_code', $fname)] = $db->f('lang_alias', $fname);
        }
    }

    public function getLang($code)
    {
        return $this->lang_list[$code];
    }

    public function exists($code)
    {
        return isset($this->lang_list[$code]);
    }

    public function getAll()
    {
        return $this->lang_list;
    }
}

?>