<?php
class Messages {

    function Messages ()
    {}

    protected static $message_array = array();

    // Set message for User
    public static function setUserMsg($usr_msg = '')
    {
        $msg =& Messages::getInstance();
        $msg->message_array['UM'][] = $usr_msg;
    }

    // Set message for User
    public static function setUserErrorMsg($usr = '')
    {
        $msg =& Messages::getInstance();
        $msg->message_array['U'][] = $usr;
    }
    // save log
    public static function setLogMsg($log = '', $file, $line)
    {
        if (ConstMisc::ADMIN_LOG) {
            $db = new Database("Messages::setLogMsg");
            $sql  = " INSERT INTO " . ConstDB::TBL_ERROR_LOG .
                    " SET " .
                    "   message     = '" . $log     . "', " .
                    "   file_name   = '" . $file    . "', " .
                    "   line_number = '" . $line    . "'";
            $db->query($sql);
        }
    }

    // Set variables for messages
    static function setMsgVariables($vars = array())
    {
        $msg =& Messages::getInstance();
        foreach ($vars as $key => $val) {
            if (array_key_exists('U', $msg->message_array))
                foreach($msg->message_array['U'] as $key1 => $val1)
                    $msg->message_array['U'][$key1] =  str_replace('$'.$key, $val, $msg->message_array['U'][$key1]);
            if (array_key_exists('UM', $msg->message_array))
                foreach($msg->message_array['UM'] as $key1 => $val1)
                    $msg->message_array['UM'][$key1] =  str_replace('$'.$key, $val, $msg->message_array['UM'][$key1]);
            if (array_key_exists('M',$msg->message_array))
                foreach($msg->message_array['M'] as $key1 => $val1)
                    $msg->message_array['M'][$key1] =  str_replace('$'.$key, $val, $msg->message_array['M'][$key1]);
            if (array_key_exists('L', $msg->message_array))
                foreach($msg->message_array['L'] as $key1 => $val1)
                    $msg->message_array['L'][$key1] =  str_replace('$'.$key, $val, $msg->message_array['L'][$key1]);
          }
    }

    public static function userErrorsEx()
    {
        $msg =& Messages::getInstance();
        return count($msg->message_array['U']);
    }

    public static function coderErrorsEx()
    {
        $msg =& Messages::getInstance();
        return count($msg->message_array['M']);
    }

    public static function userMsgEx()
    {
        $msg =& Messages::getInstance();
        return count($msg->message_array['UM']);
    }

    public static function formatUserErrors ($use_tpl = true)
    {
        $msg =& Messages::getInstance();
        $errors = '';
        if ($msg->userErrorsEx() > 0) {
            $errors = implode ('</li><li>', $msg->message_array['U']);
            $errors = '<div id="msg-error">'
                .  '<ul><li>' . $errors . '</li></ul>'
                .  '</div>';
            if ($use_tpl) {
                $tpl =& Template::getInstance();
                $tpl->assign('error', nl2br ($errors));
            }
            unset($msg->message_array['U']);
            return $errors;
        }
    }

    public static function formatUserMessages ($use_tpl = true)
    {
        $msg =& Messages::getInstance();
        $message = '';
        if ($msg->userMsgEx() > 0) {
            $message = implode ('</li><li>', $msg->message_array['UM']);
            $messages = '<div id="msg-ok">'
                .  '<ul><li>' . $message . '</li></ul>'
                .  '</div>';
        }
        if ($use_tpl) {
            $tpl =& Template::getInstance();
            $tpl->assign('msg', nl2br($messages));
        }
        unset($msg->message_array['UM']);
        return $messages;
    }

    public static function formatAll($use_tpl = true)
    {
        if (Messages::userErrorsEx() > 0) {
            // Fehlermeldungen parsen
            Messages::formatUserErrors($use_tpl);
        }
        if (Messages::userMsgEx() > 0) {
            // Messages parsen
            Messages::formatUserMessages($use_tpl);
        }
    }

    static function &getInstance()
    {
        static $msg;
        if (!is_object($msg)) {
            $msg = new Messages();
        }
        return $msg;
    }
}
?>