<?php
class User extends ActiveRecord{
    protected $DB_TABLE_NAME = ConstDB::TBL_USERS;
    /*
    protected $obligatory_fields = array(
        'login'         => "label__user_login",
        'email'         => "label__user_email"
    );
    */
    protected $obligatory_fields = array(
        'login'         => "label__user_login"
    );

    public function checkPassword($password)
    {
        return ($this->get('password') == $password);
    }

    public function setPassword($new_pass, $new_pass_confirm)
    {
        if ($new_pass != $new_pass_confirm){
            $lang =& Language::getInstance();
            Messages::setUserErrorMsg($lang->get('err__passwords_differ'));
            return false;
        }
        $this->set('password', $new_pass);
        return true;
    }

    public function checkUnique()
    {
        $login = $this->get('login');
        $email = $this->get('email');
        $lang =& Language::getInstance();
        $db = new Database(get_class($this) . "::checkUnique");
        // Проверка уникальности логина
        $sql  = " SELECT COUNT(*) AS num_rows " .
                " FROM " . $this->DB_TABLE_NAME .
                " WHERE login = '" . mysql_real_escape_string($login) . "' ";
        $db->query($sql);
        $db->nextRecord();
        if ($db->f('num_rows') > 0) {
            Messages::setUserErrorMsg($lang->get('err__user_with_same_login_exists'));
            return false;
        }
        // Проверка уникальности e-mail
        $sql  = " SELECT COUNT(*) AS num_rows " .
                " FROM " . $this->DB_TABLE_NAME .
                " WHERE email = '" . mysql_real_escape_string($email) . "' ";
        $db->query($sql);
        $db->nextRecord();
        if ($db->f('num_rows') > 0) {
            Messages::setUserErrorMsg($lang->get('err__user_with_same_email_exists'));
            return false;
        }
        return true;
    }
}
?>