<?php

class UserPacketContainer extends ActiveRecordContainer {
    protected $CLASS_NAME = "UserPacket";
    protected $user_logins = array();

    public function loadActive()
    {
        $sql  = $this->getLoadSQL(false, " WHERE time_till > '" . time() . "'");
        $fname = get_class($this) . "::loadActive";
        $this->loadBackend($sql, $fname);
    }

    protected function loadBackend($sql, $fname)
    {
        $db_fields = $this->getDbFieldNames();
        $pri_key_field = $this->getPriKeyField();
        $db = new Database($fname);
        $db->query($sql);
        while ($db->nextRecord()){
            $data = array();
            $pri_key_value = $db->f($pri_key_field);
            $packet_id = $db->f('packet_id');
            foreach ($db_fields as $field){
                $data[$field] = $db->f($field);
            }
            eval("\$this->objects[\$packet_id] = new " . $this->CLASS_NAME . "();");
            $this->objects[$packet_id]->setData($data);
            $this->user_logins[$db->f('login')] = true;
        }
    }

    public function getLogins()
    {
        return array_keys($this->user_logins);
    }

    public function loadActiveByUser($user_login)
    {
        $conditions =   " WHERE login       = '" . mysql_real_escape_string($user_login) . "'" .
                        "   AND time_till   > '" . time() . "'";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveByUser";
        $this->loadBackend($sql, $fname);
    }

    public function deleteByPackets($packet_ids)
    {
        $db = new Database(get_class($this) . "::deleteByPackets");
        $sql =  " DELETE FROM " . $this->getTableName() .
                " WHERE " .
                "   packet_id IN " . $this->createPriKeyStr($packet_ids);
        $db->query($sql);
        return $db->affectedRows();
    }

}

?>