<?php
require_once "LocalSettings.php";
requireLogin();

Navigation::userNavi();

$packet_group_name = html_entity_decode($_GET['packet_group']);
$packet_group = new PacketGroup($packet_group_name);
if (!$packet_group->isLoaded()) {
    Messages::setUserErrorMsg($lang->get("err__packet_group_doesnt_exist", array("group" => $packet_group_name)));
} else {
    $tpl->assign("packet_group", $packet_group);
    $pac_con = new PacketContainer("", $_GET['order_by'], $_GET['order_asc']);
    $pac_con->loadByGroup($packet_group_name);
    $tpl->assign("packets", $pac_con->getAll());
    $tpl->assign("table_fields", array(
        'coding'        => $lang->get("label__packet_coding"),
        'packet'        => $lang->get("label__packet_packet"),
        'port'          => $lang->get("label__packet_port"),
        'name'          => $lang->get("label__packet_name")
    ));
}

$tpl->assign("page_title", $lang->get("title__packet_group_info"));
Messages::formatAll();
$tpl->assign("main_template", "User_Packet_Group_Info.html");
$tpl->display('Fend_Index.html');
?>