<?php
require_once "./LocalSettings.php";

function validateSignature()
{
    $ik_sign_hash_str = ConstMISC::SHOP_ID          . ':' .
                        $_GET['ik_payment_amount']  . ':' .
                        $_GET['ik_payment_id']      . ':' .
                        $_GET['ik_paysystem_alias'] . ':' .
                        $_GET['ik_baggage_fields']  . ':' .
                        $_GET['ik_payment_state']   . ':' .
                        $_GET['ik_trans_id']        . ':' .
                        $_GET['ik_currency_exch']   . ':' .
                        $_GET['ik_fees_payer']      . ':' .
                        ConstMISC::SHOP_SECRET_KEY;
    $ik_sign_hash = strtoupper(md5($ik_sign_hash_str));
    return (strtoupper($_GET['ik_sign_hash']) == $ik_sign_hash);
}

if (validateSignature() && (strtolower($_GET['ik_payment_state']) == 'success')) {
    $login = $_GET['ik_payment_id'];
    $user = new User($login);
    if ($user->isLoaded()) 
	{
        $amount = floatval($_GET['ik_payment_amount']);
         if  ($amount >= 9 && $amount < 20) $bonus = 1;
		 if  ($amount >= 20 && $amount < 30) $bonus = 3;
	    if  ($amount >= 30 && $amount < 50) $bonus = 6;
	    if  ($amount >= 50 && $amount < 100) $bonus = 15;
	    if  ($amount >= 100 && $amount < 200)  $bonus = 40;
		if($amount >= 200) $bonus = 100;
        $amount = $amount + $bonus;
		$amountz = $amount - $bonus;
        $user->set("balance", $user->get("balance") + $amount);
        $bal_change = new BalanceChange();
        $bal_change->set('login',   $login);
        $bal_change->set('time',    $_GET['ik_payment_timestamp']);
        $bal_change->set('amount',  $amount);
		$bal_change->set('reason',          "<b>   Interkassa 2.0 </b>");
        $bal_change->set('details',    "  !");
        $bal_change->set('reason_login',    $user->get("login"));
		$bal_change->set('itogbalance',  $user->get("balance"));
	$bal_change->set('left_balance',  $user->get("balance"));
        $bal_change->save();
        $user->save();
    }
}
$tpl->assign("main_template", "Sys_Payment_Status.html");
$tpl->display('Fend_Index.html');
?>