<?php
require_once "LocalSettings.php";
requireLogin();

Navigation::userNavi();

/*
$user_container = new HandledUserContainer("", $_GET['order_by'], $_GET['order_asc']);
$ph = $user_container->loadWithFilter($_GET['filter_login']);
$tpl->assign("ph", $ph);
$users = $user_container->getAll();
$tpl->assign("users", $users);
$tpl->assign("items_pp", $user_container->getItemsPP());
*/

if (isset($_POST["submit_transfer"]))
{
    $current_user = $GLOBALS['user'];
    $login_to_transfer_to = $_POST["login_to_transfer_to"];
    $user_to_transfer_to = new User($login_to_transfer_to);
    if ($user_to_transfer_to == null || !$user_to_transfer_to->isLoaded())
        Messages::setUserErrorMsg($lang->get("error__no_such_user", array("login" => $login_to_transfer_to)));
    $amount = floatval($_POST["transfer_amount"]);
    if ($amount <= 0)
        Messages::setUserErrorMsg($lang->get("err__only_positive_amount_please"));
    if ($amount > $current_user->get("balance"))
        Messages::setUserErrorMsg($lang->get("err__insufficient_funds"));

    if (Messages::userErrorsEx() == 0)
    {
        $user_to_transfer_to->set("balance", $user_to_transfer_to->get("balance") + $amount);
        $user_to_transfer_to->save();

        $bal_change = new BalanceChange();
        $bal_change->set('login',           $user_to_transfer_to->get("login"));
        $bal_change->set('time',            time());
        $bal_change->set('amount',          $amount);
        $bal_change->set('reason',          "bal_reason_transfer_receive");
        $bal_change->set('details',         $current_user->get("login"));
        $bal_change->set('reason_login',    $current_user->get("login"));
		$bal_change->set('itogbalance',  $user->get("balance"));
        $bal_change->save();

        $current_user->set("balance", $current_user->get("balance") - $amount);
        $current_user->save();

        $bal_change = new BalanceChange();
        $bal_change->set('login',           $current_user->get("login"));
        $bal_change->set('time',            time());
        $bal_change->set('amount',          -$amount);
        $bal_change->set('reason',          "bal_reason_transfer_send");
        $bal_change->set('details',         $user_to_transfer_to->get("login"));
        $bal_change->set('reason_login',    $user_to_transfer_to->get("login"));
	    $bal_change->set('itogbalance',  $user->get("balance"));
        $bal_change->save();

        Messages::setUserErrorMsg ($lang->get("msg__transfer_completed", array("amount" => $amount, "user" => $user_to_transfer_to->get("login"))));

        $ssn->redirectTo($_SERVER['PHP_SELF'] . "?user=" . $user_to_transfer_to->get("login"));
        die();
    }
}

/*
$login_to_transfer_to = $_GET['edit'];
$user_to_transfer_to = new User($login_to_transfer_to);

if ($user_to_transfer_to->isLoaded())
{
    $tpl->assign("user_to_transfer_to", $user_to_transfer_to);
}
*/



$tpl->assign("table_fields", array(
    'login'         => $lang->get("label__user_login"),
    'time_added'    => $lang->get("label__user_time_added"),
    'time_edited'   => $lang->get("label__user_time_edited"),
    //'balance'       => $lang->get("label__balance"),
    //'disabled'      => $lang->get("label__user_dis"),
    //'confirmed'     => $lang->get("label__user_conf")
));

$tpl->assign("field_modifiers", array(
    //'disabled'      => "modDot",
    //'confirmed'     => "modDot",
    'time_added'    => "date",
    'time_edited'   => "date"
));

$tpl->assign('page_title',  $lang->get('navi__transfer_funds'));
Messages::formatAll();
$tpl->assign("main_template", "User_Transfer_Funds.html");
$tpl->display('Fend_Index222.html');
?>
